unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, LFN, Buttons, StylSped, ExtCtrls;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
  DirectorylistBox1.Drive:=DriveComboBox1.Drive;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  path: string;
  LongSearchRec: TLFNSearchRec;
  Error: integer;
  MyList: TStringList;
begin
  Label2.Caption:='Working...';
  Application.ProcessMessages;
  MyList:=TStringList.Create;
  path:=DirectoryListBox1.Directory;
  if path[length(path)]<>'\' then path:=path+'\';

  MyList.Clear;

  {file searching loop}
  if (LFNFindFirst(path+'*.*',faAnyFile-faVolumeID, LongSearchRec)=0) then
    repeat
      if (not(LongSearchRec.ShortName[0]=#0)) {this happens when SFN=LFN or . or ..}
        then MyList.add(lowercase(StrPas(LongSearchRec.ShortName))+' '+StrPas(LongSearchRec.Name));
    until LFNFindNext(LongSearchRec)<>0;
  LFNFindClose(LongSearchRec);

  if (MyList.Count>0) then begin {write to descript.ion if there are any files}
    MyList.add(Edit1.Text+' File descriptions');
    {add a description for the description}
    MyList.SaveToFile(path+Edit1.text);
  end;
  FileSetAttr(path+Edit1.text,faHidden); {set hidden attribute for descript.ion}

  MyList.Free;
  Label2.Caption:='Done; ready';
end;

procedure TForm1.FormShow(Sender: TObject);
var
  path: string;
begin
  if ParamCount=1 then begin {only if there is only one parameter}
    path:=ExpandFileName(ParamStr(1));
    if path[length(path)]<>'\' then path:=path+'\';
    DriveComboBox1.Drive:=path[1];
    DirectoryListBox1.Directory:=path;
    {ShowMessage('Drive letter: '+path[1]+#13+'Path: '+path);}
    Button1.Click;
    Close;
  end;
end;

end.
